#!/usr/bin/env python
# -*- coding: utf-8 -*-

from __future__ import (with_statement)
import mpd, pickle
from socket import error as socketerror
from audioscrobbler import AudioScrobblerQuery
from datetime import date
from time import sleep

HOST = 'localhost'
PORT = None
PASSWORD = None

class MPDCon():

    def __init__(self, host='localhost', port=6600, password=None):
        self.host = host
        self.port = int(port)
        self.password = password
        self.client = mpd.MPDClient()

    def connect(self):
        try:
            self.client.connect(self.host, self.port)
        except socketerror:
            return False
        return True

    def disconnect(self):
        try:
            self.mpd_client.disconnect()
        except mpd.ConnectionError, errdisco:
            print errdisco
        return True



CACHE = {}
mpd_client = MPDCon(HOST)
if mpd_client.connect():
    print 'Connected to MPD server'
    all_art = mpd_client.client.list('artist')
    mpd_client.disconnect
    print "%d artists ind database" % len(all_art)
    #for k in all_art[:10]:#limited to 10 artists
    for k in all_art:
        print 'looking for %s' % k
        as_artist_names = []
        sleep(1)
        try:
            as_artists = AudioScrobblerQuery(artist=k)
            for artist in as_artists.similar():
                as_artist_names.append(str(artist.name))
            print 'found %d similar artists' % len(as_artist_names)
            CACHE[k] = as_artist_names
        except:
            print 'nothing found for "%s"' % k
            as_artist_names = None

DATE = date.today()
stamp = {}
stamp['DATE'] = DATE
with open('similar_cache.pkl', 'wb') as cache_fd:
    print 'Saving cache to %s' % 'similar_cache.pkl'
    pickle.dump(CACHE, cache_fd, -1)
    pickle.dump(stamp, cache_fd, -1)

#
## vim: tabstop=4 expandtab shiftwidth=4
